// parent.component.ts
import { CommonModule } from '@angular/common';
import { Component, Input } from '@angular/core';
import { SHARED_IMPORTS } from '@shared';
import { NzIconModule } from 'ng-zorro-antd/icon';

@Component({
  selector: 'data-v-card',
  standalone: true,
  template: `
    <div class="card-content">
      <!-- <img src="assets/dashboard/dashboard_card_bg.jpg" style="width: 100%;" /> -->

      <div class="card-content-title">
        <div class="card-content-l">{{ title }}</div>
        <div *ngIf="showSetting" class="card-content-r">
          <span nz-icon nzType="setting" nzTheme="outline"></span>
        </div>
      </div>

      <ng-content></ng-content>
    </div>
  `,
  styleUrls: ['./card.component.less'],
  imports: [NzIconModule, CommonModule, ...SHARED_IMPORTS],
})
export class DataVCardComponent {
  @Input() showSetting = false;

  @Input() title: string = '';
}
